@echo off
rem #######################################################
rem # vrimg2exr batch conversion tool version 0.4         #
rem # yvind Schei AKA Shimakaze                          #
rem # www.ascantica.com                                   #
rem #######################################################
rem # Change these settings to decide how the tool should
rem # behave by default:
rem #
rem #### Turn half float on by default? (1=yes, 2=no)
set a=1
rem #
rem #### Turn sRGB on by default? (1=yes, 2=no)
set b=0
rem #
rem #### Activate Automatic conversion (1=yes, 2=no)
set c=0
rem #
rem #### When using automatic conversion, which
rem #### operation should be used?
rem #### Individual layers: 1, One big file: 2, Only RGB & Alpha channels: 3                           ####
set d=2
rem #
rem ####################################################### 
rem Don't change anything below unless you know what you are doing!


if '%a%'=='1' set float=-half
if '%a%'=='0' set float=
if '%b%'=='1' set srgb=-sRGB
if '%b%'=='0' set srgb=

if '%c%'=='1' (
if '%d%'=='1' goto convert
if '%d%'=='2' goto bigcon
if '%d%'=='3' goto convert
)
CLS
:start

ECHO.
ECHO Welcome to Shimakaze's vrimg2exr conversion tool
ECHO.
ECHO Currently exporting as:
if '%float%'=='-half' ECHO 16 bit floating point
if '%float%'=='' ECHO 32 bit floating point
if '%srgb%'=='-sRGB' ECHO sRGB color space
if '%srgb%'=='' ECHO Linear color space
ECHO.
ECHO Please select operation:
ECHO   1: Convert all elements to individual EXR files
ECHO   2: Convert all elements to a single EXR file
Echo   3: Convert only main RGB and Alpha channel
Echo   4: Convert a spesific element by name
ECHO   5: Display EXR file info
Echo   6: Change settings
Echo   7: Close converter
ECHO.

set choice=
set /p choice=Type the number of your choice:
if not '%choice%'=='' set choice=%choice:~0,1%
if '%choice%'=='1' goto convert
if '%choice%'=='2' goto bigcon
if '%choice%'=='3' goto convert
if '%choice%'=='4' goto convsel
if '%choice%'=='5' goto info
if '%choice%'=='6' goto settings
if '%choice%'=='7' EXIT
ECHO "%choice%" is not valid. Please try again
ECHO.
goto start

:settings
echo.
echo -half
echo  Stores the data in the .exr file as 16-bit floating point numbers.
echo  If this option is disabled, the data is stored 
echo  as 32-bit floating point numbers.
echo.
if '%float%'=='-half' (ECHO *This setting is currently enabled) else (ECHO  This setting is currently disabled)
set /p cfloat=Enable 16 bit "half float"? (1=yes, 2=no)
if '%cfloat%'=='1' set float=-half
if '%cfloat%'=='0' set float=
echo.
echo  -sRGB
echo  Converts the RGB data from the .vrimg file to the sRGB color space
echo  before writing to the .exr file. If this option is disabled specified, the
echo  data is stored in linear RGB space.
echo.
if '%float%'=='-sRGB' (ECHO *This setting is currently enabled) else (ECHO  -This setting is currently disabled)
set /p csrgb=Enable sRGB output? (1=yes, 2=no)
if '%csrgb%'=='1' set srgb=-sRGB
if '%csrgb%'=='0' set srgb=
CLS
goto start

:convert
c:\vrimg2exr.exe %1 %1_Color.exr -channel "RGB color" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Alpha.exr -channel "Alpha" %float% %srgb%
if '%c%'=='1' if '%d%'=='3' exit
if '%choice%'=='3' pause
if '%choice%'=='3' goto start
c:\vrimg2exr.exe %1 %1_Atmosphere.exr -channel "VRay_Atmosphere" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Background.exr -channel "VRay_Background" %float% %srgb%
c:\vrimg2exr.exe %1 %1_BumpNormals.exr -channel "VRay_BumpNormals" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Caustics.exr -channel "VRay_Caustics" %float% %srgb%
c:\vrimg2exr.exe %1 %1_DiffuseFilter.exr -channel "VRay_DiffuseFilter" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Global_Illum.exr -channel "VRay_GlobalIllumination" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Illuminance.exr -channel "VRay_Illuminance" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Lighting.exr -channel "VRay_Lighting" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MatteShadow.exr -channel "VRay_MatteShadow" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MtlID.exr -channel "VRay_MtlID" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Normals.exr -channel "VRay_Normals" %float% %srgb%
c:\vrimg2exr.exe %1 %1_ObjectID.exr -channel "VRay_ObjectID" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawGlobal_Illum.exr -channel "VRay_RawGlobalIllumination" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawLighting.exr -channel "VRay_RawLighting" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawReflection.exr -channel "VRay_RawReflection" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawRefraction.exr -channel "VRay_RawRefraction" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawShadow.exr -channel "VRay_RawShadow" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RawTotalLighting.exr -channel "VRay_RawTotalLighting" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Reflection.exr -channel "VRay_Reflection" %float% %srgb%
c:\vrimg2exr.exe %1 %1_ReflectionFilter.exr -channel "VRay_ReflectionFilter" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Refraction.exr -channel "VRay_Refraction" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RefractionFilter.exr -channel "VRay_RefractionFilter" %float% %srgb%
c:\vrimg2exr.exe %1 %1_RenderID.exr -channel "VRay_RenderID" %float% %srgb%
c:\vrimg2exr.exe %1 %1_SampleRate.exr -channel "VRay_SampleRate" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Self_Illum.exr -channel "VRay_SelfIllumination" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Shadows.exr -channel "VRay_Shadows" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Specular.exr -channel "VRay_Specular" %float% %srgb%
c:\vrimg2exr.exe %1 %1_TotalLighting.exr -channel "VRay_TotalLighting" %float% %srgb%
c:\vrimg2exr.exe %1 %1_UnclampedColor.exr -channel "VRay_UnclampedColor" %float% %srgb%
c:\vrimg2exr.exe %1 %1_Velocity.exr -channel "VRay_Velocity" %float% %srgb%
c:\vrimg2exr.exe %1 %1_WireColor.exr -channel "VRay_WireColor" %float% %srgb%
c:\vrimg2exr.exe %1 %1_ZDepth.exr -channel "VRay_ZDepth" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement.exr -channel "MultiMatteElement" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement1.exr -channel "MultiMatteElement1" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement2.exr -channel "MultiMatteElement2" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement3.exr -channel "MultiMatteElement3" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement4.exr -channel "MultiMatteElement4" %float% %srgb%
c:\vrimg2exr.exe %1 %1_MultimatteElement5.exr -channel "MultiMatteElement5" %float% %srgb%
if '%c%'=='1' exit
ECHO.
pause
CLS
goto start

:bigcon
c:\vrimg2exr.exe %1
if '%c%'=='1' exit
ECHO.
pause
CLS
goto start

:info
CLS
c:\vrimg2exr.exe %1 -info
ECHO.
pause
goto start

:convsel
set elmt=
set /p elmt=Write the name of the element you want to convert:
set elmtname=%elmt: =_%
c:\vrimg2exr.exe %1 %1_%elmtname%.exr -channel "%elmt%" %float% %srgb%
pause
CLS
goto start